// Copyright The NRI Plugins Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"

	v1alpha1 "github.com/containers/nri-plugins/pkg/apis/config/v1alpha1"
	scheme "github.com/containers/nri-plugins/pkg/generated/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// BalloonsPoliciesGetter has a method to return a BalloonsPolicyInterface.
// A group's client should implement this interface.
type BalloonsPoliciesGetter interface {
	BalloonsPolicies(namespace string) BalloonsPolicyInterface
}

// BalloonsPolicyInterface has methods to work with BalloonsPolicy resources.
type BalloonsPolicyInterface interface {
	Create(ctx context.Context, balloonsPolicy *v1alpha1.BalloonsPolicy, opts v1.CreateOptions) (*v1alpha1.BalloonsPolicy, error)
	Update(ctx context.Context, balloonsPolicy *v1alpha1.BalloonsPolicy, opts v1.UpdateOptions) (*v1alpha1.BalloonsPolicy, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, balloonsPolicy *v1alpha1.BalloonsPolicy, opts v1.UpdateOptions) (*v1alpha1.BalloonsPolicy, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.BalloonsPolicy, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.BalloonsPolicyList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.BalloonsPolicy, err error)
	BalloonsPolicyExpansion
}

// balloonsPolicies implements BalloonsPolicyInterface
type balloonsPolicies struct {
	*gentype.ClientWithList[*v1alpha1.BalloonsPolicy, *v1alpha1.BalloonsPolicyList]
}

// newBalloonsPolicies returns a BalloonsPolicies
func newBalloonsPolicies(c *ConfigV1alpha1Client, namespace string) *balloonsPolicies {
	return &balloonsPolicies{
		gentype.NewClientWithList[*v1alpha1.BalloonsPolicy, *v1alpha1.BalloonsPolicyList](
			"balloonspolicies",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *v1alpha1.BalloonsPolicy { return &v1alpha1.BalloonsPolicy{} },
			func() *v1alpha1.BalloonsPolicyList { return &v1alpha1.BalloonsPolicyList{} }),
	}
}
